package ch.kousz.adrian.encfs;

import ch.kousz.adrian.util.StringGenerator;
import java.io.File;
import org.mrpdaemon.sec.encfs.EncFSBinaryConfig;
import org.mrpdaemon.sec.encfs.EncFSConfig;
import org.mrpdaemon.sec.encfs.EncFSConfigParser;
import org.mrpdaemon.sec.encfs.EncFSUtil;

public class EncFSBrute
{
	public static void main(String[] args)
	throws Exception
	{
		String filename = args[0];
		String charset = args[1];
		int minLength = Integer.parseInt(args[2]);

		EncFSConfig config = EncFSConfigParser.parseFile(new File(filename));
		EncFSBinaryConfig binaryConfig = EncFSBinaryConfig.from(config);

		for (String pw: new StringGenerator(charset, minLength)) {
			System.err.println("Trying: " + pw);
			boolean ok = EncFSUtil.checkPassword(binaryConfig, pw);
			if (ok) {
				System.out.println(pw);
				break;
			}
		}
	}
}
